signatureColored = '[|cff00FF7FA|cff00ff00G|cff00FF7FA|r]';
function agaInit()
	AutoGroupAccept:SetScript("Onevent", agaEvent);
	AutoGroupAccept:RegisterEvent("PARTY_INVITE_REQUEST"); -- Register Event on Party invite
	AutoGroupAccept:RegisterEvent("ADDON_LOADED"); -- Fired when saved variables are loaded
	function get_key_for_value( t, value )
		for k,v in pairs(t) do
			if v==value then return k
			end
		end
		return nil
	end
	--------------------------------------------------------------------------------------------------
	-- Commands --------------------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------------
	SLASH_AGA1 = '/aga';
	function SlashCmdList.AGA(msg, editbox)
		local argString = msg
		local argTable = {}
		for word in argString:gmatch("%S+") do table.insert(argTable, word) end
		if argTable[1] == 'toggle' then
		--------------------------------------------------------------------------------------------------
		-- Toggle commands -------------------------------------------------------------------------------
		--------------------------------------------------------------------------------------------------
			 if argTable[2] == 'friend' or argTable[2] == 'friends' then
					 if sIsFriendBool == true then
						sIsFriendBool = false;
						print(signatureColored.." Accept friend(s) off");
					 else
						sIsFriendBool = true;
						print(signatureColored.." Accept friend(s) on");
					 end
			 elseif argTable[2] == 'bnfriend' or argTable[2] == 'bnfriends' then
					if sBNIsFriendBool == true then
						sBNIsFriendBool = false;
						print(signatureColored.." Accept Battle.NET friend(s) off");
					 else
						sBNIsFriendBool = true;
						print(signatureColored.." Accept Battle.NET friend(s) on");
					 end
			 elseif argTable[2] == 'guild' or argTable[2] == 'guildies' then
					if sIsGuildBool == true then
						sIsGuildBool = false;
						print(signatureColored.." Accept guild member(s) off");
					 else
						sIsGuildBool = true;
						print(signatureColored.." Accept guild member(s) on");
					end
			 elseif argTable[2] == 'addon' or argTable[2] == 'plugin' then
					if sIsActive == true then
						sIsActive = false;
						print(signatureColored.." |cffcc0000AutoGroupAccept not accepting invites.");
					 else
						sIsActive = true;
						print(signatureColored.." |cff00cc00AutoGroupAccept accepting invites.");
					end
			 else
				print(signatureColored.." |cff00FF7F/aga |cff00ff00toggle|r friends |cff00E5EEor|r bnfriends |cff00E5EEor|r guildies");
			 end
	 elseif argTable[1] == 'help' or argTable[1] == 'h' or argTable[1] == '?' then
		--------------------------------------------------------------------------------------------------
		-- Help commands ---------------------------------------------------------------------------------
		--------------------------------------------------------------------------------------------------	 
		print("|cff00FF7FAuto|cff00ff00Group|cff00FF7FAccept|r |cffBABABAcommands:");
		print("|cffBABABAGeneral commands:");
		print("|cff00FF7F/aga |rhelp");
		print("|cff00FF7F/aga |rshow |cff00E5EEor|r list");
		print("|cff00FF7F/aga |rabout");
		print("|cff00FF7F/aga |rsilence |cff00E5EEor|r quiet |cff00E5EEor|r mute");
		print("|cff00FF7F/aga |rpurgeall -- Empties character lists.");
		print("|cffBABABAGroup toggle commands:");
		print("|cff00FF7F/aga |cff00ff00toggle|r friends |cff00E5EEor|r friend");
		print("|cff00FF7F/aga |cff00ff00toggle|r bnfriends |cff00E5EEor|r bnfriend");
		print("|cff00FF7F/aga |cff00ff00toggle|r guild |cff00E5EEor|r guildies");
		print("|cff00FF7F/aga |cff00ff00toggle|r addon |cff00E5EEor|r plugin");
		print("|cffBABABACharacter specific commands:");
		print("|cff00FF7F/aga |radd|r <character>");
		print("|cff00FF7F/aga |rremove|r <character>");
		print("|cff00FF7F/aga |rblock|r <character>");	
		print("|cff00FF7F/aga |runblock|r <character>");		
	elseif argTable[1] == 'list' or argTable[1] == 'show' then
		--------------------------------------------------------------------------------------------------
		-- Character Listing commands --------------------------------------------------------------------
		--------------------------------------------------------------------------------------------------
		local addedList = "";
		local blockedList = "";
		if sIsFriendBool then
			addedList = addedList .. ' [|cff00FF7FFriends|r] ';
		end
		if sBNIsFriendBool then
			addedList = addedList .. ' [|cff00FF7FBNET Friends|r] ';
		end
		if sIsGuildBool then
			addedList = addedList .. ' [|cff00FF7FGuildies|r] ';
		end
		for _, value,k in pairs(sTableAdded) do
			addedList = addedList .. value .. '  ';
		end
		if addedList == "" then
			addedList = "|cffBABABANo added characters.";
		end
		print(signatureColored .. ' Allowed: '..addedList);
		for _, value,k in pairs(sTableBlocked) do
			blockedList = blockedList .. value .. '  ';
		end
		if blockedList == "" then
			blockedList = "|cffBABABANo blocked characters.";
		end
		print(signatureColored .. ' Blocked: '..blockedList);
	elseif argTable[1] == 'add' then
		if argTable[2] ~= nil and argTable[2] ~= '' then
			local addingCharacter = true;
			for _, value in pairs(sTableAdded) do
				if string.upper(value) == string.upper(argTable[2]) then
				  addingCharacter = false;
				end
			end
			if addingCharacter then
				table.insert (sTableAdded, argTable[2]);
				print(signatureColored .. ' ' .. argTable[2] .. ' has been added.');
			 else
				print(signatureColored .. ' ' .. argTable[2] .. ' is already added.');
			 end 
		else
		print(signatureColored .. ' Invalid command usage, |cff00FF7F/aga |cff00ff00add|r <character>');
		end
	elseif argTable[1] == 'purgeall' then
		sTableAdded = {}
		sTableBlocked = {}
		print(signatureColored .. ' Allowed and Blocked list emptied. ');
	elseif argTable[1] == 'remove' then
		if argTable[2] ~= nil and argTable[2] ~= '' then
			local removingCharacter = false;
			local n = 0
			for _, value,k in pairs(sTableAdded) do
				if string.upper(value) == string.upper(argTable[2]) and removingCharacter == false then
				  removingCharacter = true;
				  n = get_key_for_value( sTableAdded, value )
				end
			end
			if removingCharacter then
				sTableAdded[n] = nil;
				print(signatureColored .. ' ' .. argTable[2] .. ' has been removed.');	 
			 else
				print(signatureColored .. ' ' .. argTable[2] .. ' is not added.');
			 end
		else
		print(signatureColored .. ' Invalid command usage, |cff00FF7F/aga |cff00ff00remove|r <character>');
		end
	elseif argTable[1] == 'block' then
		if argTable[2] ~= nil and argTable[2] ~= '' then
			local addingCharacter = true;
			for _, value,k in pairs(sTableBlocked) do
				if string.upper(value) == string.upper(argTable[2]) then
				  addingCharacter = false;
				end
			end
			if addingCharacter then
				table.insert (sTableBlocked, argTable[2]);
				print(signatureColored .. ' ' .. argTable[2] .. ' has been blocked.');	 
			 else
				print(signatureColored .. ' ' .. argTable[2] .. ' is already blocked.');
			 end
		else
		print(signatureColored .. ' Invalid command usage, |cff00FF7F/aga |cff00ff00block|r <character>');
		end
	elseif argTable[1] == 'unblock' then
	if argTable[2] ~= nil and argTable[2] ~= '' then
		local removingCharacter = false;
		local n = 0
		for _, value in pairs(sTableBlocked) do
			if string.upper(value) == string.upper(argTable[2]) and removingCharacter == false then
			  removingCharacter = true;
			  n = get_key_for_value( sTableBlocked, value )
			end
		end
		if removingCharacter then
			sTableBlocked[n] = nil;
			print(signatureColored .. ' ' .. argTable[2] .. ' has been unblocked.');	 
		 else
			print(signatureColored .. ' ' .. argTable[2] .. ' is not blocked.');
		 end
	else
		print(signatureColored .. ' Invalid command usage, |cff00FF7F/aga |cff00ff00unblock|r <character>');
	end
	elseif argTable[1] == 'about' then
		print("");
		print("|cff00FF7FAuto|cff00ff00Group|cff00FF7FAccept|r |cffBABABAabout:");
		print("AutoGroupAccept is an addon that as the name implies automatically accepts the invites from the people you choose.");
		print("Made by |cff00ff00Utriax|r from Stormrage (US)");
	elseif argTable[1] == 'silence' or argTable[1] == 'quiet' or argTable[1] == 'mute' then
		 if sIsSilence == true then
			sIsSilence = false;
			print(signatureColored.." Silence activated.");
		 else
			sIsSilence = true;
			print(signatureColored.." Silence deactivated.");
		 end
	 else
		print(signatureColored.." That is not an usable command, use |cff00FF7F/aga |cff00ff00help|r for more commands.");
	 end
	end	
	if sIsSilence then
		print(signatureColored.." Addon loaded.");
	end
end
function agaEvent(self, event, sender)
	--------------------------------------------------------------------------------------------------
	-- First time Setup ------------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------------
	if (event == "ADDON_LOADED") then
	-- first time setup
	if sIsFriendBool == nil and sBNIsFriendBool == nil and sIsGuildBool == nil and sIsActive == nil and sTableAdded == nil and sTableBlocked == nil and sIsSilence == nil then
		print(signatureColored.." Initializing first time setup!");
	end
		-- also fixes some shizzle when you fudge with the files.
		if sIsFriendBool == nil then
			sIsFriendBool = false;
		end
		if sBNIsFriendBool == nil then
			sBNIsFriendBool = false;
		end
		if sIsGuildBool == nil then
			sIsGuildBool = false;
		end
		if sIsActive == nil then
			sIsActive = true;
		end
		if sIsSilence == nil then
			sIsSilence = false;
		end
		if sTableAdded == nil then
			sTableAdded = {}
		end
		if sTableBlocked == nil then
			sTableBlocked = {}
		end
	end
	--------------------------------------------------------------------------------------------------
	-- Accepting invites from friends ----------------------------------------------------------------
	--------------------------------------------------------------------------------------------------
	if (event == "PARTY_INVITE_REQUEST") then
		local playerNumber = GetNumGroupMembers()
		if sIsActive == true and playerNumber == 0 then
			local isAllowed = false
			-- Get all character names -----------------------------------------------------------------------
			local onlineFriends = GetNumFriends() -- Get all the friends that are on.
			local numBNetOnline = BNGetNumFriends() -- Get the BN Friends that are on
			local numGuildMembers, numOnline, numOnlineAndMobile = GetNumGuildMembers() -- get Guildies
			local checkTableCharacters = {} -- Characters to check later on.
			if sIsFriendBool == true then
				for i=1, onlineFriends do
					local name, level, class, area, connected, status, note, RAF = GetFriendInfo(i);
					if connected == true then
						table.insert(checkTableCharacters, name);
					end
				end
			end
			if sBNIsFriendBool == true then
				for i=1, numBNetOnline do
					local presenceID, presenceName, battleTag, isBattleTagPresence, toonName, toonID, client, isOnline, lastOnline, isAFK, isDND, messageText, noteText, isRIDFriend, broadcastTime, canSoR = BNGetFriendInfo(i)
					if isOnline == true then
						table.insert(checkTableCharacters, toonName);
					end
				end
			end
			if sIsGuildBool == true then
				for i=1, numOnline do
					local fullName, rank, rankIndex, level, class, zone, note, officernote, online, status, classFileName, achievementPoints, achievementRank, isMobile, canSoR, reputation = GetGuildRosterInfo(i)
					if online == true then
						nameChar, realmName = fullName:match("([^,]+)-([^,]+)")
						table.insert(checkTableCharacters, nameChar);
					end
				end
			end
			-- Check if sender is in the table -- 
			if sTableAdded ~= nil then
				for _, value in pairs(sTableAdded) do
					if string.upper(value) == string.upper(sender) then
					  isAllowed = true;
					end
				end
			end			
			-- Check if sender is in the table -- 
			for _, value in pairs(checkTableCharacters) do
				if value == sender and isAllowed == false then
				  isAllowed = true;
				end
			end
			-- Check if User is blocked -- sTableBlocked
			for _, value in pairs(sTableBlocked) do
				if value == sender then
				  isAllowed = false;
				  if sIsSilence then
					print(signatureColored.." blocked character |cff00FF7F".. tostring(sender) .."|r tried to invite you.");
				  end
				end
			end
			-- Check if everything checks out --
			if isAllowed then
				AcceptGroup();
				if sIsSilence then
					print(signatureColored.." character |cff00FF7F".. tostring(sender) .."|r has invited you.");
				end
				for i=1, STATICPOPUP_NUMDIALOGS do
					local dlg = _G["StaticPopup"..i]
					if dlg.which == "PARTY_INVITE" then
						dlg.inviteAccepted = 1
					break
					end
				end
				StaticPopup_Hide("PARTY_INVITE");
			end
		end
	end
end



